=== modified file 'NEWS'
--- NEWS	2005-10-30 14:56:26 +0000
+++ NEWS	2005-10-31 20:52:50 +0000
@@ -1,7 +1,12 @@
-For 0.7
+UNRELEASED CHANGES
 
   IMPROVEMENTS:
 
+    * "bzr INIT dir" now initializes the specified directory, and creates 
+      it if it does not exist.  (John Arbash Meinel)
+
+    * Better zsh completion script.  (Steve Borho)
+
     * 'bzr diff' now returns 1 when there are changes in the working 
       tree. (Robert Collins)
 
@@ -10,6 +15,19 @@
       location in the ~/.bazaar/branches.conf configuration file.
       (Robert Collins)
 
+  BUG FIXES:
+
+    * SFTP can walk up to the root path without index errors. (Robert Collins)
+
+    * Fix bugs in running bzr with 'python -O'.  (Martin Pool)
+
+  TESTING:
+
+    * Fix selftest asking for passwords when there are no SFTP keys.  
+      (Robey Pointer, Jelmer Vernooij) 
+
+    * Fix selftest run with 'python -O'.  (Martin Pool)
+
   INTERNALS:
 
     * WorkingTree.pull has been split across Branch and WorkingTree,
@@ -36,8 +54,14 @@
     * Some option parsing errors will raise 'BzrOptionError', allowing 
       granular detection for decorating commands. (Robert Collins).
 
+    * Branch.read_working_inventory has moved to
+      WorkingTree.read_working_inventory. This necessitated changes to
+      Branch.get_root_id, and a move of Branch.set_inventory to WorkingTree
+      as well. To make it clear that a WorkingTree cannot always be obtained
+      Branch.working_tree() will raise 'errors.NoWorkingTree' if one cannot
+      be obtained. (Robert Collins)
 
-bzr 0.6rc1 2005-10-27
+bzr 0.6 2005-10-28
 
   IMPROVEMENTS:
   
@@ -88,8 +112,6 @@
     * 'bzr branch' will now set the branch-name to the last component of the
       output directory, if one was supplied.
 
-    * New sftp transport, based on Paramiko.  (Robey Pointer)
-
     * If the option 'post_commit' is set to one (or more) python function
       names (must be in the bzrlib namespace), then they will be invoked
       after the commit has completed, with the branch and revision_id as

=== modified file 'bzr'
--- bzr	2005-10-27 03:43:23 +0000
+++ bzr	2005-10-31 17:21:15 +0000
@@ -53,7 +53,7 @@
                      "\n")
     raise
 
-if bzrlib.version_info[:3] != (0, 6, 0):
+if bzrlib.version_info[:3] != (0, 7, 0):
     sys.stderr.write("bzr: WARNING: bzrlib version doesn't match the bzr program.\n"
             "This may indicate an installation problem.\n"
             "bzrlib from %s is version %r\n"

=== renamed file 'bzr-man.py' => 'bzr_man.py'
--- bzr-man.py	2005-09-28 04:58:18 +0000
+++ bzr_man.py	2005-10-28 19:35:13 +0000
@@ -21,30 +21,6 @@
 
 import os, sys
 
-try:
-    version_info = sys.version_info
-except AttributeError:
-    version_info = 1, 5 # 1.5 or older
-
-
-REINVOKE = "__BZR_REINVOKE"    
-NEED_VERS = (2, 3)
-
-if version_info < NEED_VERS:
-    if not os.environ.has_key(REINVOKE):
-        # mutating os.environ doesn't work in old Pythons
-        os.putenv(REINVOKE, "1")
-        for python in 'python2.4', 'python2.3':
-            try:
-                os.execvp(python, [python] + sys.argv)
-            except OSError:
-                pass
-    print >>sys.stderr, "bzr-man.py: error: cannot find a suitable python interpreter"
-    print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
-    sys.exit(1)
-if hasattr(os, "unsetenv"):
-    os.unsetenv(REINVOKE)
-
 import bzrlib, bzrlib.help
 
 #>>> code taken from bzr (C) Canonical
@@ -126,7 +102,7 @@
         bzrcmd = self.params["bzrcmd"]
         outfile.write('.SH "COMMAND OVERVIEW"\n')
         for (command,usage,descr) in self.command_usage:
-            outfile.write('.TP\n.B "%s %s"\n%s\n\n' % (bzrcmd, usage, descr))
+            outfile.write('.TP\n.B "%s %s"\n%s\n' % (bzrcmd, usage, descr))
 
 
 class HelpReader:
@@ -196,7 +172,6 @@
 Path where
 .B "%(bzrcmd)s"
 is to look for external command.
-
 .TP
 .I "BZREMAIL"
 E-Mail address of the user. Overrides
@@ -204,14 +179,12 @@
 .IR "EMAIL" .
 Example content:
 .I "John Doe <john@example.com>"
-
 .TP
 .I "EMAIL"
 E-Mail address of the user. Overridden by the content of the file
 .I "~/.bzr.conf/email"
 and of the environment variable
 .IR "BZREMAIL" .
-
 .SH "FILES"
 .TP
 .I "~/.bzr.conf/"
@@ -222,7 +195,6 @@
 .I "EMAIL"
 environment variable. Example content:
 .I "John Doe <john@example.com>"
-
 .SH "SEE ALSO"
 .UR http://www.bazaar-ng.org/
 .BR http://www.bazaar-ng.org/,

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-10-27 03:50:40 +0000
+++ bzrlib/__init__.py	2005-10-31 17:21:15 +0000
@@ -84,9 +84,9 @@
 del locale
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
-__version__ = version_string = '0.6rc1'
+__version__ = version_string = '0.7pre'
 # same format as sys.version_info
-version_info = (0, 6, 0, 'rc', 1)
+version_info = (0, 7, 0, 'pre', 0)
 
 
 def get_bzr_revision():

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-10-28 04:34:46 +0000
+++ bzrlib/add.py	2005-10-30 23:58:46 +0000
@@ -90,8 +90,8 @@
 
     file_list = _prepare_file_list(file_list)
     user_list = file_list[:]
-    inv = branch.read_working_inventory()
     tree = branch.working_tree()
+    inv = tree.read_working_inventory()
     count = 0
 
     for f in file_list:

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-10-30 18:39:32 +0000
+++ bzrlib/branch.py	2005-11-04 17:26:05 +0000
@@ -15,6 +15,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+import shutil
 import sys
 import os
 import errno
@@ -33,7 +34,8 @@
 from bzrlib.errors import (BzrError, InvalidRevisionNumber, InvalidRevisionId,
                            NoSuchRevision, HistoryMissing, NotBranchError,
                            DivergedBranches, LockError, UnlistableStore,
-                           UnlistableBranch, NoSuchFile, NotVersionedError)
+                           UnlistableBranch, NoSuchFile, NotVersionedError,
+                           NoWorkingTree)
 from bzrlib.textui import show_status
 from bzrlib.revision import (Revision, is_ancestor, get_intervening_revisions,
                              NULL_REVISION)
@@ -224,10 +226,6 @@
     def set_root_id(self, file_id):
         raise NotImplementedError('set_root_id is abstract')
 
-    def read_working_inventory(self):
-        """Read the working inventory."""
-        raise NotImplementedError('read_working_inventory is abstract')
-
     def add(self, files, ids=None):
         """Make files versioned.
 
@@ -256,10 +254,6 @@
         """Print `file` to stdout."""
         raise NotImplementedError('print_file is abstract')
 
-    # FIXME: this doesn't need to be a branch method
-    def set_inventory(self, new_inventory_list):
-        raise NotImplementedError('set_inventory is abstract')
-
     def unknowns(self):
         """Return all unknown files.
 
@@ -677,10 +671,8 @@
     def __str__(self):
         return '%s(%r)' % (self.__class__.__name__, self._transport.base)
 
-
     __repr__ = __str__
 
-
     def __del__(self):
         if self._lock_mode or self._lock:
             # XXX: This should show something every time, and be suitable for
@@ -696,7 +688,6 @@
         # should never expect their __del__ function to run.
         if hasattr(self, 'cache_root') and self.cache_root is not None:
             try:
-                import shutil
                 shutil.rmtree(self.cache_root)
             except:
                 pass
@@ -892,12 +883,13 @@
 
     def get_root_id(self):
         """See Branch.get_root_id."""
-        inv = self.read_working_inventory()
+        inv = self.get_inventory(self.last_revision())
         return inv.root.file_id
 
+    @needs_write_lock
     def set_root_id(self, file_id):
         """See Branch.set_root_id."""
-        inv = self.read_working_inventory()
+        inv = self.working_tree().read_working_inventory()
         orig_root_id = inv.root.file_id
         del inv._byid[inv.root.file_id]
         inv.root.file_id = file_id
@@ -908,14 +900,6 @@
                 entry.parent_id = inv.root.file_id
         self._write_inventory(inv)
 
-    @needs_read_lock
-    def read_working_inventory(self):
-        """See Branch.read_working_inventory."""
-        # ElementTree does its own conversion from UTF-8, so open in
-        # binary.
-        f = self.controlfile('inventory', 'rb')
-        return bzrlib.xml5.serializer_v5.read_inventory(f)
-
     @needs_write_lock
     def _write_inventory(self, inv):
         """Update the working inventory.
@@ -932,9 +916,6 @@
         
         mutter('wrote working inventory')
             
-    inventory = property(read_working_inventory, _write_inventory, None,
-                         """Inventory for the working copy.""")
-
     @needs_write_lock
     def add(self, files, ids=None):
         """See Branch.add."""
@@ -951,7 +932,7 @@
         else:
             assert(len(ids) == len(files))
 
-        inv = self.read_working_inventory()
+        inv = self.working_tree().read_working_inventory()
         for f,file_id in zip(files, ids):
             if is_control_file(f):
                 raise BzrError("cannot add control file %s" % quotefn(f))
@@ -991,26 +972,6 @@
             raise BzrError("%r is not present in revision %s" % (file, revno))
         tree.print_file(file_id)
 
-    # FIXME: this doesn't need to be a branch method
-    def set_inventory(self, new_inventory_list):
-        """See Branch.set_inventory."""
-        from bzrlib.inventory import Inventory, InventoryEntry
-        inv = Inventory(self.get_root_id())
-        for path, file_id, parent, kind in new_inventory_list:
-            name = os.path.basename(path)
-            if name == "":
-                continue
-            # fixme, there should be a factory function inv,add_?? 
-            if kind == 'directory':
-                inv.add(inventory.InventoryDirectory(file_id, name, parent))
-            elif kind == 'file':
-                inv.add(inventory.InventoryFile(file_id, name, parent))
-            elif kind == 'symlink':
-                inv.add(inventory.InventoryLink(file_id, name, parent))
-            else:
-                raise BzrError("unknown kind %r" % kind)
-        self._write_inventory(inv)
-
     def unknowns(self):
         """See Branch.unknowns."""
         return self.working_tree().unknowns()
@@ -1112,7 +1073,12 @@
         # bzr 0.0.6 and later imposes the constraint that the inventory_id
         # must be the same as its revision, so this is trivial.
         if revision_id == None:
-            return Inventory(self.get_root_id())
+            # This does not make sense: if there is no revision,
+            # then it is the current tree inventory surely ?!
+            # and thus get_root_id() is something that looks at the last
+            # commit on the branch, and the get_root_id is an inventory check.
+            raise NotImplementedError
+            # return Inventory(self.get_root_id())
         else:
             return self.get_inventory(revision_id)
 
@@ -1187,6 +1153,8 @@
         # much more complex to keep consistent than our careful .bzr subset.
         # instead, we should say that working trees are local only, and optimise
         # for that.
+        if self._transport.base.find('://') != -1:
+            raise NoWorkingTree(self.base)
         return WorkingTree(self.base, branch=self)
 
     @needs_write_lock
@@ -1304,7 +1272,7 @@
         from bzrlib.atomicfile import AtomicFile
         from bzrlib.osutils import backup_file
         
-        inv = self.read_working_inventory()
+        inv = self.working_tree().read_working_inventory()
         if old_tree is None:
             old_tree = self.basis_tree()
         old_inv = old_tree.inventory

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-10-30 14:56:26 +0000
+++ bzrlib/builtins.py	2005-10-31 17:17:04 +0000
@@ -27,7 +27,7 @@
 from bzrlib.commands import Command, display_command
 from bzrlib.branch import Branch
 from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError, NotBranchError
-from bzrlib.errors import DivergedBranches, NoSuchFile
+from bzrlib.errors import DivergedBranches, NoSuchFile, NoWorkingTree
 from bzrlib.option import Option
 from bzrlib.revisionspec import RevisionSpec
 import bzrlib.trace
@@ -262,7 +262,7 @@
     def run(self, revision=None, show_ids=False):
         b = Branch.open_containing('.')[0]
         if revision is None:
-            inv = b.read_working_inventory()
+            inv = b.working_tree().read_working_inventory()
         else:
             if len(revision) > 1:
                 raise BzrCommandError('bzr inventory --revision takes'
@@ -560,7 +560,7 @@
     def run(self, dir='.'):
         b = Branch.open_containing(dir)[0]
         old_inv = b.basis_tree().inventory
-        new_inv = b.read_working_inventory()
+        new_inv = b.working_tree().read_working_inventory()
 
         renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
         renames.sort()
@@ -655,7 +655,8 @@
     """Display list of versioned directories in this branch."""
     @display_command
     def run(self):
-        for name, ie in Branch.open_containing('.')[0].read_working_inventory().directories():
+        for name, ie in (Branch.open_containing('.')[0].working_tree().
+                         read_working_inventory().directories()):
             if name == '':
                 print '.'
             else:
@@ -675,8 +676,20 @@
         bzr status
         bzr commit -m 'imported project'
     """
-    def run(self):
-        Branch.initialize('.')
+    takes_args = ['location?']
+    def run(self, location=None):
+        from bzrlib.branch import Branch
+        if location is None:
+            location = '.'
+        else:
+            # The path has to exist to initialize a
+            # branch inside of it.
+            # Just using os.mkdir, since I don't
+            # believe that we want to create a bunch of
+            # locations if the user supplies an extended path
+            if not os.path.exists(location):
+                os.mkdir(location)
+        Branch.initialize(location)
 
 
 class cmd_diff(Command):
@@ -838,7 +851,11 @@
         if filename:
             b, fp = Branch.open_containing(filename)
             if fp != '':
-                file_id = b.read_working_inventory().path2id(fp)
+                try:
+                    inv = b.working_tree().read_working_inventory()
+                except NoWorkingTree:
+                    inv = b.get_inventory(b.last_revision())
+                file_id = inv.path2id(fp)
             else:
                 file_id = None  # points to branch root
         else:
@@ -897,7 +914,7 @@
     @display_command
     def run(self, filename):
         b, relpath = Branch.open_containing(filename)[0]
-        inv = b.read_working_inventory()
+        inv = b.working_tree().read_working_inventory()
         file_id = inv.path2id(relpath)
         for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
             print "%6d %s" % (revno, what)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-10-30 14:56:26 +0000
+++ bzrlib/errors.py	2005-10-30 23:58:46 +0000
@@ -127,6 +127,14 @@
         self.branch = branch
 
 
+class NoWorkingTree(BzrNewError):
+    """No WorkingTree exists for %s(base)."""
+    
+    def __init__(self, base):
+        BzrNewError.__init__(self)
+        self.base = base
+        
+
 class BzrCommandError(BzrError):
     # Error from malformed user command
     # This is being misused as a generic exception

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-10-27 23:41:45 +0000
+++ bzrlib/merge.py	2005-10-30 23:58:46 +0000
@@ -111,7 +111,7 @@
                         rename(new_name, name)
                         self.this_tree.branch.rename_one(relpath, new_path)
                         assert self.this_tree.id2path(file_id) == relpath
-                        self.this_tree._inventory = self.this_tree.branch.inventory
+                        self.this_tree._inventory = self.this_tree.read_working_inventory()
                         assert self.this_tree.id2path(file_id) == new_path
         except OSError, e:
             if e.errno != errno.EEXIST and e.errno != errno.ENOTEMPTY:
@@ -523,13 +523,13 @@
                 path = path[2:]
             adjust_ids.append((path, id))
         if len(adjust_ids) > 0:
-            self.this_branch.set_inventory(self.regen_inventory(adjust_ids))
+            self.this_branch.working_tree().set_inventory(self.regen_inventory(adjust_ids))
         conflicts = self.conflict_handler.conflicts
         self.conflict_handler.finalize()
         return conflicts
 
     def regen_inventory(self, new_entries):
-        old_entries = self.this_branch.read_working_inventory()
+        old_entries = self.this_branch.working_tree().read_working_inventory()
         new_inventory = {}
         by_path = {}
         new_entries_map = {} 

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-10-29 23:48:45 +0000
+++ bzrlib/selftest/__init__.py	2005-10-31 20:40:26 +0000
@@ -488,7 +488,7 @@
         """
         # XXX: It's OK to just create them using forward slashes on windows?
         for name in shape:
-            assert isinstance(name, basestring)
+            self.assert_(isinstance(name, basestring))
             if name[-1] == '/':
                 os.mkdir(name[:-1])
             else:
@@ -515,7 +515,6 @@
         logging.info('an info message')
         warning('something looks dodgy...')
         logging.debug('hello, test is running')
-        ## assert 0
 
 
 def filter_suite_by_re(suite, pattern):

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-10-30 14:56:26 +0000
+++ bzrlib/selftest/blackbox.py	2005-10-31 20:40:26 +0000
@@ -62,6 +62,20 @@
     def test_init_branch(self):
         self.runbzr(['init'])
 
+        # Can it handle subdirectories as well?
+        self.runbzr('init subdir1')
+        self.assert_(os.path.exists('subdir1'))
+        self.assert_(os.path.exists('subdir1/.bzr'))
+
+        self.runbzr('init subdir2/nothere', retcode=2)
+        
+        os.mkdir('subdir2')
+        self.runbzr('init subdir2')
+        self.runbzr('init subdir2', retcode=1)
+
+        self.runbzr('init subdir2/subsubdir1')
+        self.assert_(os.path.exists('subdir2/subsubdir1/.bzr'))
+
     def test_whoami(self):
         # this should always identify something, if only "john@localhost"
         self.runbzr("whoami")
@@ -140,29 +154,29 @@
 
         file('foo.tmp', 'wt').write('tmp files are ignored')
         self.assertEquals(list(b.unknowns()), [])
-        assert self.capture('unknowns') == ''
+        self.assertEquals(self.capture('unknowns'), '')
 
         file('foo.c', 'wt').write('int main() {}')
         self.assertEquals(list(b.unknowns()), ['foo.c'])
-        assert self.capture('unknowns') == 'foo.c\n'
+        self.assertEquals(self.capture('unknowns'), 'foo.c\n')
 
         self.runbzr(['add', 'foo.c'])
-        assert self.capture('unknowns') == ''
+        self.assertEquals(self.capture('unknowns'), '')
 
         # 'ignore' works when creating the .bzignore file
         file('foo.blah', 'wt').write('blah')
         self.assertEquals(list(b.unknowns()), ['foo.blah'])
         self.runbzr('ignore *.blah')
         self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rU').read() == '*.blah\n'
+        self.assertEquals(file('.bzrignore', 'rU').read(), '*.blah\n')
 
         # 'ignore' works when then .bzrignore file already exists
         file('garh', 'wt').write('garh')
         self.assertEquals(list(b.unknowns()), ['garh'])
-        assert self.capture('unknowns') == 'garh\n'
+        self.assertEquals(self.capture('unknowns'), 'garh\n')
         self.runbzr('ignore garh')
         self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rU').read() == '*.blah\ngarh\n'
+        self.assertEquals(file('.bzrignore', 'rU').read(), '*.blah\ngarh\n')
 
     def test_revert(self):
         self.runbzr('init')
@@ -255,34 +269,34 @@
         self.runbzr('export ../latest')
         self.assertEqual(file('../latest/goodbye', 'rt').read(), 'baz')
         self.runbzr('export ../first -r 1')
-        assert not os.path.exists('../first/goodbye')
+        self.assert_(not os.path.exists('../first/goodbye'))
         self.assertEqual(file('../first/hello', 'rt').read(), 'foo')
         self.runbzr('export ../first.gz -r 1')
         self.assertEqual(file('../first.gz/hello', 'rt').read(), 'foo')
         self.runbzr('export ../first.bz2 -r 1')
         self.assertEqual(file('../first.bz2/hello', 'rt').read(), 'foo')
         self.runbzr('export ../first.tar -r 1')
-        assert os.path.isfile('../first.tar')
+        self.assert_(os.path.isfile('../first.tar'))
         from tarfile import TarFile
         tf = TarFile('../first.tar')
-        assert 'first/hello' in tf.getnames(), tf.getnames()
+        self.assert_('first/hello' in tf.getnames(), tf.getnames())
         self.assertEqual(tf.extractfile('first/hello').read(), 'foo')
         self.runbzr('export ../first.tar.gz -r 1')
-        assert os.path.isfile('../first.tar.gz')
+        self.assert_(os.path.isfile('../first.tar.gz'))
         self.runbzr('export ../first.tbz2 -r 1')
-        assert os.path.isfile('../first.tbz2')
+        self.assert_(os.path.isfile('../first.tbz2'))
         self.runbzr('export ../first.tar.bz2 -r 1')
-        assert os.path.isfile('../first.tar.bz2')
+        self.assert_(os.path.isfile('../first.tar.bz2'))
         self.runbzr('export ../first.tar.tbz2 -r 1')
-        assert os.path.isfile('../first.tar.tbz2')
+        self.assert_(os.path.isfile('../first.tar.tbz2'))
         from bz2 import BZ2File
         tf = TarFile('../first.tar.tbz2', 
                      fileobj=BZ2File('../first.tar.tbz2', 'r'))
-        assert 'first.tar/hello' in tf.getnames(), tf.getnames()
+        self.assert_('first.tar/hello' in tf.getnames(), tf.getnames())
         self.assertEqual(tf.extractfile('first.tar/hello').read(), 'foo')
         self.runbzr('export ../first2.tar -r 1 --root pizza')
         tf = TarFile('../first2.tar')
-        assert 'pizza/hello' in tf.getnames(), tf.getnames()
+        self.assert_('pizza/hello' in tf.getnames(), tf.getnames())
 
     def test_diff(self):
         self.example_branch()
@@ -365,8 +379,7 @@
         b = Branch.open('../b')
         a.get_revision_xml(b.last_revision())
         self.log('pending merges: %s', a.pending_merges())
-        assert a.pending_merges() == [b.last_revision()], "Assertion %s %s" \
-            % (a.pending_merges(), b.last_patch())
+        self.assertEquals(a.pending_merges(), [b.last_revision()])
         self.runbzr('commit -m merged')
         self.runbzr('merge ../b -r last:1')
         self.assertEqual(Branch.open('.').pending_merges(), [])
@@ -399,12 +412,12 @@
         print >> file('sub/c.txt', 'ab'), "something"
         self.runbzr(('commit', '-m', 'Modified a.txt'))
         self.runbzr('merge ../a/', retcode=1)
-        assert os.path.exists('sub/a.txt.THIS')
-        assert os.path.exists('sub/a.txt.BASE')
+        self.assert_(os.path.exists('sub/a.txt.THIS'))
+        self.assert_(os.path.exists('sub/a.txt.BASE'))
         os.chdir('../a')
         self.runbzr('merge ../b/', retcode=1)
-        assert os.path.exists('sub/a.txt.OTHER')
-        assert os.path.exists('sub/a.txt.BASE')
+        self.assert_(os.path.exists('sub/a.txt.OTHER'))
+        self.assert_(os.path.exists('sub/a.txt.BASE'))
 
     def test_pull(self):
         """Pull changes from one branch to another."""
@@ -430,9 +443,9 @@
         os.chdir('../a')
         a = Branch.open('.')
         b = Branch.open('../b')
-        assert a.revision_history() == b.revision_history()[:-1]
+        self.assertEquals(a.revision_history(), b.revision_history()[:-1])
         self.runbzr('pull ../b')
-        assert a.revision_history() == b.revision_history()
+        self.assertEquals(a.revision_history(), b.revision_history())
         self.runbzr('commit -m blah2 --unchanged')
         os.chdir('../b')
         self.runbzr('commit -m blah3 --unchanged')
@@ -450,7 +463,7 @@
         self.runbzr('commit -m blah4 --unchanged')
         os.chdir('../b/subdir')
         self.runbzr('pull ../../a')
-        assert a.revision_history()[-1] == b.revision_history()[-1]
+        self.assertEquals(a.revision_history()[-1], b.revision_history()[-1])
         self.runbzr('commit -m blah5 --unchanged')
         self.runbzr('commit -m blah6 --unchanged')
         os.chdir('..')
@@ -643,21 +656,21 @@
         self.runbzr('commit -m this')
         self.runbzr('merge ../other --show-base', retcode=1)
         conflict_text = file('hello').read()
-        assert '<<<<<<<' in conflict_text
-        assert '>>>>>>>' in conflict_text
-        assert '=======' in conflict_text
-        assert '|||||||' in conflict_text
-        assert 'hi world' in conflict_text
+        self.assert_('<<<<<<<' in conflict_text)
+        self.assert_('>>>>>>>' in conflict_text)
+        self.assert_('=======' in conflict_text)
+        self.assert_('|||||||' in conflict_text)
+        self.assert_('hi world' in conflict_text)
         self.runbzr('revert')
         self.runbzr('resolve --all')
         self.runbzr('merge ../other', retcode=1)
         conflict_text = file('hello').read()
-        assert '|||||||' not in conflict_text
-        assert 'hi world' not in conflict_text
+        self.assert_('|||||||' not in conflict_text)
+        self.assert_('hi world' not in conflict_text)
         result = self.runbzr('conflicts', backtick=1)
         self.assertEquals(result, "hello\nquestion\n")
         result = self.runbzr('status', backtick=1)
-        assert "conflicts:\n  hello\n  question\n" in result, result
+        self.assert_("conflicts:\n  hello\n  question\n" in result, result)
         self.runbzr('resolve hello')
         result = self.runbzr('conflicts', backtick=1)
         self.assertEquals(result, "question\n")
@@ -781,36 +794,32 @@
         self.assertEquals(capture('unknowns'), 'test.txt\n')
 
         out = capture("status")
-        assert out == 'unknown:\n  test.txt\n'
+        self.assertEquals(out, 'unknown:\n  test.txt\n')
 
         out = capture("status --all")
-        assert out == "unknown:\n  test.txt\n"
+        self.assertEquals(out, "unknown:\n  test.txt\n")
 
         out = capture("status test.txt --all")
-        assert out == "unknown:\n  test.txt\n"
+        self.assertEquals(out, "unknown:\n  test.txt\n")
 
         f = file('test2.txt', 'wt')
         f.write('goodbye cruel world...\n')
         f.close()
 
         out = capture("status test.txt")
-        assert out == "unknown:\n  test.txt\n"
+        self.assertEquals(out, "unknown:\n  test.txt\n")
 
         out = capture("status")
-        assert out == ("unknown:\n"
-                       "  test.txt\n"
-                       "  test2.txt\n")
+        self.assertEquals(out, ("unknown:\n" "  test.txt\n" "  test2.txt\n"))
 
         os.unlink('test2.txt')
 
         progress("command aliases")
         out = capture("st --all")
-        assert out == ("unknown:\n"
-                       "  test.txt\n")
+        self.assertEquals(out, ("unknown:\n" "  test.txt\n"))
 
         out = capture("stat")
-        assert out == ("unknown:\n"
-                       "  test.txt\n")
+        self.assertEquals(out, ("unknown:\n" "  test.txt\n"))
 
         progress("command help")
         runbzr("help st")
@@ -827,16 +836,15 @@
         progress("adding a file")
 
         runbzr("add test.txt")
-        assert capture("unknowns") == ''
-        assert capture("status --all") == ("added:\n"
-                                                "  test.txt\n")
+        self.assertEquals(capture("unknowns"), '')
+        self.assertEquals(capture("status --all"), ("added:\n" "  test.txt\n"))
 
         progress("rename newly-added file")
         runbzr("rename test.txt hello.txt")
-        assert os.path.exists("hello.txt")
-        assert not os.path.exists("test.txt")
+        self.assert_(os.path.exists("hello.txt"))
+        self.assert_(not os.path.exists("test.txt"))
 
-        assert capture("revno") == '0\n'
+        self.assertEquals(capture("revno"), '0\n')
 
         progress("add first revision")
         runbzr(['commit', '-m', 'add first revision'])
@@ -853,21 +861,21 @@
         self.assertEqual(capture("relpath sub2/hello.txt"),
                          os.path.join("sub2", "hello.txt\n"))
 
-        assert exists("sub2")
-        assert exists("sub2/hello.txt")
-        assert not exists("sub1")
-        assert not exists("hello.txt")
+        self.assert_(exists("sub2"))
+        self.assert_(exists("sub2/hello.txt"))
+        self.assert_(not exists("sub1"))
+        self.assert_(not exists("hello.txt"))
 
         runbzr(['commit', '-m', 'commit with some things moved to subdirs'])
 
         mkdir("sub1")
         runbzr('add sub1')
         runbzr('move sub2/hello.txt sub1')
-        assert not exists('sub2/hello.txt')
-        assert exists('sub1/hello.txt')
+        self.assert_(not exists('sub2/hello.txt'))
+        self.assert_(exists('sub1/hello.txt'))
         runbzr('move sub2 sub1')
-        assert not exists('sub2')
-        assert exists('sub1/sub2')
+        self.assert_(not exists('sub2'))
+        self.assert_(exists('sub1/sub2'))
 
         runbzr(['commit', '-m', 'rename nested subdirectories'])
 
@@ -875,16 +883,16 @@
         self.assertEquals(capture('root')[:-1],
                           os.path.join(self.test_dir, 'branch1'))
         runbzr('move ../hello.txt .')
-        assert exists('./hello.txt')
+        self.assert_(exists('./hello.txt'))
         self.assertEquals(capture('relpath hello.txt'),
                           os.path.join('sub1', 'sub2', 'hello.txt') + '\n')
-        assert capture('relpath ../../sub1/sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
+        self.assertEquals(capture('relpath ../../sub1/sub2/hello.txt'), os.path.join('sub1', 'sub2', 'hello.txt\n'))
         runbzr(['commit', '-m', 'move to parent directory'])
         chdir('..')
-        assert capture('relpath sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
+        self.assertEquals(capture('relpath sub2/hello.txt'), os.path.join('sub1', 'sub2', 'hello.txt\n'))
 
         runbzr('move sub2/hello.txt .')
-        assert exists('hello.txt')
+        self.assert_(exists('hello.txt'))
 
         f = file('hello.txt', 'wt')
         f.write('some nice new content\n')
@@ -896,7 +904,7 @@
 
         runbzr('commit -F msg.tmp')
 
-        assert capture('revno') == '5\n'
+        self.assertEquals(capture('revno'), '5\n')
         runbzr('export -r 5 export-5.tmp')
         runbzr('export export.tmp')
 
@@ -905,15 +913,15 @@
         runbzr('log -v --forward')
         runbzr('log -m', retcode=1)
         log_out = capture('log -m commit')
-        assert "this is my new commit\n  and" in log_out
-        assert "rename nested" not in log_out
-        assert 'revision-id' not in log_out
-        assert 'revision-id' in capture('log --show-ids -m commit')
+        self.assert_("this is my new commit\n  and" in log_out)
+        self.assert_("rename nested" not in log_out)
+        self.assert_('revision-id' not in log_out)
+        self.assert_('revision-id' in capture('log --show-ids -m commit'))
 
         log_out = capture('log --line')
         for line in log_out.splitlines():
-            assert len(line) <= 79, len(line)
-        assert "this is my new commit and" in log_out
+            self.assert_(len(line) <= 79, len(line))
+        self.assert_("this is my new commit and" in log_out)
 
 
         progress("file with spaces in name")
@@ -936,26 +944,26 @@
             runbzr('init')
             os.symlink("NOWHERE1", "link1")
             runbzr('add link1')
-            assert self.capture('unknowns') == ''
+            self.assertEquals(self.capture('unknowns'), '')
             runbzr(['commit', '-m', '1: added symlink link1'])
     
             mkdir('d1')
             runbzr('add d1')
-            assert self.capture('unknowns') == ''
+            self.assertEquals(self.capture('unknowns'), '')
             os.symlink("NOWHERE2", "d1/link2")
-            assert self.capture('unknowns') == 'd1/link2\n'
+            self.assertEquals(self.capture('unknowns'), 'd1/link2\n')
             # is d1/link2 found when adding d1
             runbzr('add d1')
-            assert self.capture('unknowns') == ''
+            self.assertEquals(self.capture('unknowns'), '')
             os.symlink("NOWHERE3", "d1/link3")
-            assert self.capture('unknowns') == 'd1/link3\n'
+            self.assertEquals(self.capture('unknowns'), 'd1/link3\n')
             runbzr(['commit', '-m', '2: added dir, symlink'])
     
             runbzr('rename d1 d2')
             runbzr('move d2/link2 .')
             runbzr('move link1 d2')
-            assert os.readlink("./link2") == "NOWHERE2"
-            assert os.readlink("d2/link1") == "NOWHERE1"
+            self.assertEquals(os.readlink("./link2"), "NOWHERE2")
+            self.assertEquals(os.readlink("d2/link1"), "NOWHERE1")
             runbzr('add d2/link3')
             runbzr('diff', retcode=1)
             runbzr(['commit', '-m', '3: rename of dir, move symlinks, add link3'])
@@ -965,67 +973,67 @@
             os.unlink("d2/link1")
             os.symlink("TARGET 1", "d2/link1")
             runbzr('diff', retcode=1)
-            assert self.capture("relpath d2/link1") == "d2/link1\n"
+            self.assertEquals(self.capture("relpath d2/link1"), "d2/link1\n")
             runbzr(['commit', '-m', '4: retarget of two links'])
     
             runbzr('remove d2/link1')
-            assert self.capture('unknowns') == 'd2/link1\n'
+            self.assertEquals(self.capture('unknowns'), 'd2/link1\n')
             runbzr(['commit', '-m', '5: remove d2/link1'])
             # try with the rm alias
             runbzr('add d2/link1')
             runbzr(['commit', '-m', '6: add d2/link1'])
             runbzr('rm d2/link1')
-            assert self.capture('unknowns') == 'd2/link1\n'
+            self.assertEquals(self.capture('unknowns'), 'd2/link1\n')
             runbzr(['commit', '-m', '7: remove d2/link1'])
     
             os.mkdir("d1")
             runbzr('add d1')
             runbzr('rename d2/link3 d1/link3new')
-            assert self.capture('unknowns') == 'd2/link1\n'
+            self.assertEquals(self.capture('unknowns'), 'd2/link1\n')
             runbzr(['commit', '-m', '8: remove d2/link1, move/rename link3'])
             
             runbzr(['check'])
             
             runbzr(['export', '-r', '1', 'exp1.tmp'])
             chdir("exp1.tmp")
-            assert listdir_sorted(".") == [ "link1" ]
-            assert os.readlink("link1") == "NOWHERE1"
+            self.assertEquals(listdir_sorted("."), [ "link1" ])
+            self.assertEquals(os.readlink("link1"), "NOWHERE1")
             chdir("..")
             
             runbzr(['export', '-r', '2', 'exp2.tmp'])
             chdir("exp2.tmp")
-            assert listdir_sorted(".") == [ "d1", "link1" ]
+            self.assertEquals(listdir_sorted("."), [ "d1", "link1" ])
             chdir("..")
             
             runbzr(['export', '-r', '3', 'exp3.tmp'])
             chdir("exp3.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert listdir_sorted("d2") == [ "link1", "link3" ]
-            assert os.readlink("d2/link1") == "NOWHERE1"
-            assert os.readlink("link2")    == "NOWHERE2"
+            self.assertEquals(listdir_sorted("."), [ "d2", "link2" ])
+            self.assertEquals(listdir_sorted("d2"), [ "link1", "link3" ])
+            self.assertEquals(os.readlink("d2/link1"), "NOWHERE1")
+            self.assertEquals(os.readlink("link2")   , "NOWHERE2")
             chdir("..")
             
             runbzr(['export', '-r', '4', 'exp4.tmp'])
             chdir("exp4.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert os.readlink("d2/link1") == "TARGET 1"
-            assert os.readlink("link2")    == "TARGET 2"
-            assert listdir_sorted("d2") == [ "link1", "link3" ]
+            self.assertEquals(listdir_sorted("."), [ "d2", "link2" ])
+            self.assertEquals(os.readlink("d2/link1"), "TARGET 1")
+            self.assertEquals(os.readlink("link2")   , "TARGET 2")
+            self.assertEquals(listdir_sorted("d2"), [ "link1", "link3" ])
             chdir("..")
             
             runbzr(['export', '-r', '5', 'exp5.tmp'])
             chdir("exp5.tmp")
-            assert listdir_sorted(".") == [ "d2", "link2" ]
-            assert os.path.islink("link2")
-            assert listdir_sorted("d2")== [ "link3" ]
+            self.assertEquals(listdir_sorted("."), [ "d2", "link2" ])
+            self.assert_(os.path.islink("link2"))
+            self.assert_(listdir_sorted("d2")== [ "link3" ])
             chdir("..")
             
             runbzr(['export', '-r', '8', 'exp6.tmp'])
             chdir("exp6.tmp")
             self.assertEqual(listdir_sorted("."), [ "d1", "d2", "link2"])
-            assert listdir_sorted("d1") == [ "link3new" ]
-            assert listdir_sorted("d2") == []
-            assert os.readlink("d1/link3new") == "NOWHERE3"
+            self.assertEquals(listdir_sorted("d1"), [ "link3new" ])
+            self.assertEquals(listdir_sorted("d2"), [])
+            self.assertEquals(os.readlink("d1/link3new"), "NOWHERE3")
             chdir("..")
         else:
             progress("skipping symlink tests")

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-10-26 10:03:47 +0000
+++ bzrlib/selftest/test_commit.py	2005-10-30 23:58:46 +0000
@@ -196,13 +196,13 @@
         b.move(['hello'], 'a')
         r2 = 'test@rev-2'
         b.commit('two', rev_id=r2, allow_pointless=False)
-        self.check_inventory_shape(b.inventory,
+        self.check_inventory_shape(b.working_tree().read_working_inventory(),
                                    ['a', 'a/hello', 'b'])
 
         b.move(['b'], 'a')
         r3 = 'test@rev-3'
         b.commit('three', rev_id=r3, allow_pointless=False)
-        self.check_inventory_shape(b.inventory,
+        self.check_inventory_shape(b.working_tree().read_working_inventory(),
                                    ['a', 'a/hello', 'a/b'])
         self.check_inventory_shape(b.get_revision_inventory(r3),
                                    ['a', 'a/hello', 'a/b'])
@@ -211,7 +211,7 @@
                os.sep.join(['a', 'b']))
         r4 = 'test@rev-4'
         b.commit('four', rev_id=r4, allow_pointless=False)
-        self.check_inventory_shape(b.inventory,
+        self.check_inventory_shape(b.working_tree().read_working_inventory(),
                                    ['a', 'a/b/hello', 'a/b'])
 
         inv = b.get_revision_inventory(r4)

=== modified file 'bzrlib/selftest/test_conflicts.py'
--- bzrlib/selftest/test_conflicts.py	2005-10-06 03:15:08 +0000
+++ bzrlib/selftest/test_conflicts.py	2005-10-31 20:40:26 +0000
@@ -36,8 +36,8 @@
         self.assertEqual(len(list(tree.list_files())), 3)
         conflicts = list(tree.iter_conflicts())
         self.assertEqual(len(conflicts), 2)
-        assert 'hello' in conflicts
-        assert 'hello.sploo' in conflicts
+        self.assert_('hello' in conflicts)
+        self.assert_('hello.sploo' in conflicts)
         os.unlink('hello.BASE')
         os.unlink('hello.sploo.BASE')
         self.assertEqual(len(list(tree.iter_conflicts())), 0)

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-10-24 17:42:46 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-10-31 20:40:26 +0000
@@ -364,18 +364,18 @@
         builder.add_file("3", "0", "name5", "hello3", 0755)
         builder.change_name("3", this="name6")
         cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["2"].is_boring())
-        assert(cset.entries["1"].name == "name1")
-        assert(cset.entries["1"].new_name == "name2")
-        assert(cset.entries["3"].is_boring())
+        self.assert_(cset.entries["2"].is_boring())
+        self.assert_(cset.entries["1"].name == "name1")
+        self.assert_(cset.entries["1"].new_name == "name2")
+        self.assert_(cset.entries["3"].is_boring())
         for tree in (builder.this, builder.other, builder.base):
-            assert(tree.dir != builder.dir and 
+            self.assert_(tree.dir != builder.dir and 
                    tree.dir.startswith(builder.dir))
             for path in tree.inventory_dict.itervalues():
                 fullpath = tree.abs_path(path)
-                assert(fullpath.startswith(tree.dir))
-                assert(not path.startswith(tree.dir))
-                assert os.path.exists(fullpath)
+                self.assert_(fullpath.startswith(tree.dir))
+                self.assert_(not path.startswith(tree.dir))
+                self.assert_(os.path.exists(fullpath))
         builder.apply_changeset(cset)
         builder.cleanup()
         builder = MergeBuilder()
@@ -394,16 +394,16 @@
         builder.add_file("4", "1", "file2", "hello2", 0644)
         builder.add_file("5", "1", "file3", "hello3", 0644)
         builder.change_parent("3", other="2")
-        assert(Inventory(builder.other.inventory_dict).get_parent("3") == "2")
+        self.assert_(Inventory(builder.other.inventory_dict).get_parent("3") == "2")
         builder.change_parent("4", this="2")
-        assert(Inventory(builder.this.inventory_dict).get_parent("4") == "2")
+        self.assert_(Inventory(builder.this.inventory_dict).get_parent("4") == "2")
         builder.change_parent("5", base="2")
-        assert(Inventory(builder.base.inventory_dict).get_parent("5") == "2")
+        self.assert_(Inventory(builder.base.inventory_dict).get_parent("5") == "2")
         cset = builder.merge_changeset(ApplyMerge3)
         for id in ("1", "2", "4", "5"):
-            assert(cset.entries[id].is_boring())
-        assert(cset.entries["3"].parent == "1")
-        assert(cset.entries["3"].new_parent == "2")
+            self.assert_(cset.entries[id].is_boring())
+        self.assert_(cset.entries["3"].parent == "1")
+        self.assert_(cset.entries["3"].new_parent == "2")
         builder.apply_changeset(cset)
         builder.cleanup()
 
@@ -432,9 +432,9 @@
         builder = self.contents_test_success(backup_merge)
         def backup_exists(file_id):
             return os.path.exists(builder.this.full_path(file_id)+"~")
-        assert backup_exists("1")
-        assert backup_exists("2")
-        assert not backup_exists("3")
+        self.assert_(backup_exists("1"))
+        self.assert_(backup_exists("2"))
+        self.assert_(not backup_exists("3"))
         builder.cleanup()
 
     def do_contents_test(self, merge_factory):
@@ -453,23 +453,23 @@
         builder.add_file("3", "0", "name5", "text3", 0744)
         builder.add_file("4", "0", "name6", "text4", 0744)
         builder.remove_file("4", base=True)
-        assert not builder.cset.entries["4"].is_boring()
+        self.assert_(not builder.cset.entries["4"].is_boring())
         builder.change_contents("3", this="text6")
         cset = builder.merge_changeset(merge_factory)
-        assert(cset.entries["1"].contents_change is not None)
+        self.assert_(cset.entries["1"].contents_change is not None)
         if isclass(merge_factory):
-            assert(isinstance(cset.entries["1"].contents_change,
-                          merge_factory))
-            assert(isinstance(cset.entries["2"].contents_change,
-                          merge_factory))
-        assert(cset.entries["3"].is_boring())
-        assert(cset.entries["4"].is_boring())
+            self.assert_(isinstance(cset.entries["1"].contents_change,
+                          merge_factory))
+            self.assert_(isinstance(cset.entries["2"].contents_change,
+                          merge_factory))
+        self.assert_(cset.entries["3"].is_boring())
+        self.assert_(cset.entries["4"].is_boring())
         builder.apply_changeset(cset)
-        assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
-        assert(file(builder.this.full_path("2"), "rb").read() == "text2" )
-        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
-        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
-        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
+        self.assert_(file(builder.this.full_path("1"), "rb").read() == "text4" )
+        self.assert_(file(builder.this.full_path("2"), "rb").read() == "text2" )
+        self.assert_(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
+        self.assert_(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
+        self.assert_(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
         return builder
 
     def contents_test_conflicts(self, merge_factory):
@@ -497,8 +497,8 @@
         builder.change_target("1", this="target2")
         builder.change_target("2", base="target2")
         builder.change_target("3", other="target2")
-        assert builder.cset.entries['2'].contents_change !=\
-            builder.cset.entries['3'].contents_change
+        self.assertNotEqual(builder.cset.entries['2'].contents_change,
+                            builder.cset.entries['3'].contents_change)
         cset = builder.merge_changeset(ApplyMerge3)
         builder.apply_changeset(cset)
         self.assertEqual(builder.this.get_symlink_target("1"), "target2")
@@ -515,14 +515,14 @@
         builder.add_file("3", "0", "name3", "text3", 0755)
         builder.change_perms("3", this=0644)
         cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["1"].metadata_change is not None)
-        assert(isinstance(cset.entries["1"].metadata_change, ExecFlagMerge))
-        assert(isinstance(cset.entries["2"].metadata_change, ExecFlagMerge))
-        assert(cset.entries["3"].is_boring())
+        self.assert_(cset.entries["1"].metadata_change is not None)
+        self.assert_(isinstance(cset.entries["1"].metadata_change, ExecFlagMerge))
+        self.assert_(isinstance(cset.entries["2"].metadata_change, ExecFlagMerge))
+        self.assert_(cset.entries["3"].is_boring())
         builder.apply_changeset(cset)
-        assert(os.lstat(builder.this.full_path("1")).st_mode &0100 == 0000)
-        assert(os.lstat(builder.this.full_path("2")).st_mode &0100 == 0100)
-        assert(os.lstat(builder.this.full_path("3")).st_mode &0100 == 0000)
+        self.assert_(os.lstat(builder.this.full_path("1")).st_mode &0100 == 0000)
+        self.assert_(os.lstat(builder.this.full_path("2")).st_mode &0100 == 0100)
+        self.assert_(os.lstat(builder.this.full_path("3")).st_mode &0100 == 0000)
         builder.cleanup();
 
 
@@ -576,9 +576,9 @@
         file('b/file', 'wb').write('this contents contents\n')
         b.commit('this revision', allow_pointless=False)
         self.assertEqual(merge(['a', -1], [None, None], this_dir='b'), 1)
-        assert os.path.lexists('b/file.THIS')
-        assert os.path.lexists('b/file.BASE')
-        assert os.path.lexists('b/file.OTHER')
+        self.assert_(os.path.lexists('b/file.THIS'))
+        self.assert_(os.path.lexists('b/file.BASE'))
+        self.assert_(os.path.lexists('b/file.OTHER'))
         self.assertRaises(WorkingTreeNotRevision, merge, ['a', -1], 
                           [None, None], this_dir='b', check_clean=False,
                           merge_type=WeaveMerge)
@@ -588,10 +588,10 @@
         os.unlink('b/file.BASE')
         self.assertEqual(merge(['a', -1], [None, None], this_dir='b', 
                                check_clean=False, merge_type=WeaveMerge), 1)
-        assert os.path.lexists('b/file')
-        assert os.path.lexists('b/file.THIS')
-        assert not os.path.lexists('b/file.BASE')
-        assert os.path.lexists('b/file.OTHER')
+        self.assert_(os.path.lexists('b/file'))
+        self.assert_(os.path.lexists('b/file.THIS'))
+        self.assert_(not os.path.lexists('b/file.BASE'))
+        self.assert_(os.path.lexists('b/file.OTHER'))
 
     def test_merge_unrelated(self):
         """Sucessfully merges unrelated branches with no common names"""
@@ -606,7 +606,7 @@
         b.add('b_file')
         b.commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
-        assert os.path.lexists('a/b_file')
+        self.assert_(os.path.lexists('a/b_file'))
         self.assertEqual(a.pending_merges(), [b.last_revision()]) 
 
     def test_merge_unrelated_conflicting(self):
@@ -622,6 +622,6 @@
         b.add('file')
         b.commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
-        assert os.path.lexists('a/file')
-        assert os.path.lexists('a/file.moved')
+        self.assert_(os.path.lexists('a/file'))
+        self.assert_(os.path.lexists('a/file.moved'))
         self.assertEqual(a.pending_merges(), [b.last_revision()]) 

=== modified file 'bzrlib/selftest/test_smart_add.py'
--- bzrlib/selftest/test_smart_add.py	2005-10-18 06:30:47 +0000
+++ bzrlib/selftest/test_smart_add.py	2005-10-30 23:58:46 +0000
@@ -16,7 +16,7 @@
         branch = Branch.initialize(".")
         smart_add((".",), recurse=True)
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_dot_from_subdir(self):
         """Test adding . from a subdir of the tree.""" 
@@ -27,7 +27,7 @@
         os.chdir("original")
         smart_add((".",), recurse=True)
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_tree_from_above_tree(self):
         """Test adding a tree from above the tree.""" 
@@ -39,7 +39,7 @@
         branch = Branch.initialize("branch")
         smart_add(("branch",))
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_above_tree_preserves_tree(self):
         """Test nested trees are not affect by an add above them."""
@@ -56,13 +56,13 @@
         child_branch = Branch.initialize("original/child")
         smart_add((".",), True, add_reporter_null)
         for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
+            self.assertNotEqual((path, branch.working_tree().path2id(path)),
                                 (path, None))
         for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
+            self.assertEqual((path, branch.working_tree().path2id(path)),
                              (path, None))
         for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
+            self.assertEqual(child_branch.working_tree().path2id(path), None)
 
     def test_add_paths(self):
         """Test smart-adding a list of paths."""
@@ -72,7 +72,7 @@
         branch = Branch.initialize(".")
         smart_add(paths)
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
             
 class TestSmartAddBranch(TestCaseInTempDir):
     """Test smart adds with a specified branch."""
@@ -85,7 +85,7 @@
         branch = Branch.initialize(".")
         smart_add_branch(branch, (".",))
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_dot_from_subdir(self):
         """Test adding . from a subdir of the tree.""" 
@@ -96,7 +96,7 @@
         os.chdir("original")
         smart_add_branch(branch, (".",))
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_tree_from_above_tree(self):
         """Test adding a tree from above the tree.""" 
@@ -108,7 +108,7 @@
         branch = Branch.initialize("branch")
         smart_add_branch(branch, ("branch",))
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
     def test_add_above_tree_preserves_tree(self):
         """Test nested trees are not affect by an add above them."""
@@ -123,13 +123,13 @@
         child_branch = Branch.initialize("original/child")
         smart_add_branch(branch, (".",))
         for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
+            self.assertNotEqual((path, branch.working_tree().path2id(path)),
                                 (path, None))
         for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
+            self.assertEqual((path, branch.working_tree().path2id(path)),
                              (path, None))
         for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
+            self.assertEqual(child_branch.working_tree().path2id(path), None)
 
     def test_add_paths(self):
         """Test smart-adding a list of paths."""
@@ -139,7 +139,7 @@
         branch = Branch.initialize(".")
         smart_add_branch(branch, paths)
         for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
+            self.assertNotEqual(branch.working_tree().path2id(path), None)
 
 class TestAddCallbacks(TestCaseInTempDir):
 

=== modified file 'bzrlib/selftest/testdiff.py'
--- bzrlib/selftest/testdiff.py	2005-08-25 12:46:42 +0000
+++ bzrlib/selftest/testdiff.py	2005-10-31 20:40:26 +0000
@@ -7,42 +7,43 @@
     output.seek(0, 0)
     return output.readlines()
 
-def check_patch(lines):
-    assert len(lines) > 1, \
-        "Not enough lines for a file header for patch:\n%s" % "".join(lines)
-    assert lines[0].startswith ('---'), \
-        'No orig line for patch:\n%s' % "".join(lines)
-    assert lines[1].startswith ('+++'), \
-        'No mod line for patch:\n%s' % "".join(lines)
-    assert len(lines) > 2, \
-        "No hunks for patch:\n%s" % "".join(lines)
-    assert lines[2].startswith('@@'),\
-        "No hunk header for patch:\n%s" % "".join(lines)
-    assert '@@' in lines[2][2:], \
-        "Unterminated hunk header for patch:\n%s" % "".join(lines)
-
 class TestDiff(TestCase):
     def test_add_nl(self):
         """diff generates a valid diff for patches that add a newline"""
         lines = udiff_lines(['boo'], ['boo\n'])
-        check_patch(lines)
-        assert lines[4] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[4]
+        self.check_patch(lines)
+        self.assertEquals(lines[4], '\\ No newline at end of file\n')
+            ## "expected no-nl, got %r" % lines[4]
 
     def test_add_nl_2(self):
         """diff generates a valid diff for patches that change last line and
         add a newline.
         """
         lines = udiff_lines(['boo'], ['goo\n'])
-        check_patch(lines)
-        assert lines[4] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[4]
+        self.check_patch(lines)
+        self.assertEquals(lines[4], '\\ No newline at end of file\n')
+            ## "expected no-nl, got %r" % lines[4]
 
     def test_remove_nl(self):
         """diff generates a valid diff for patches that change last line and
         add a newline.
         """
         lines = udiff_lines(['boo\n'], ['boo'])
-        check_patch(lines)
-        assert lines[5] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[5]
+        self.check_patch(lines)
+        self.assertEquals(lines[5], '\\ No newline at end of file\n')
+            ## "expected no-nl, got %r" % lines[5]
+
+    def check_patch(self, lines):
+        self.assert_(len(lines) > 1)
+            ## "Not enough lines for a file header for patch:\n%s" % "".join(lines)
+        self.assert_(lines[0].startswith ('---'))
+            ## 'No orig line for patch:\n%s' % "".join(lines)
+        self.assert_(lines[1].startswith ('+++'))
+            ## 'No mod line for patch:\n%s' % "".join(lines)
+        self.assert_(len(lines) > 2)
+            ## "No hunks for patch:\n%s" % "".join(lines)
+        self.assert_(lines[2].startswith('@@'))
+            ## "No hunk header for patch:\n%s" % "".join(lines)
+        self.assert_('@@' in lines[2][2:])
+            ## "Unterminated hunk header for patch:\n%s" % "".join(lines)
+

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-10-24 08:37:38 +0000
+++ bzrlib/selftest/testfetch.py	2005-10-31 20:40:26 +0000
@@ -42,20 +42,20 @@
         os.mkdir(name)
         return Branch.initialize(name)
             
-    assert not has_revision(br_b, br_a.revision_history()[3])
-    assert has_revision(br_b, br_a.revision_history()[2])
-    assert len(br_b.revision_history()) == 7
-    assert greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0] == 0
+    self.assertFalse(has_revision(br_b, br_a.revision_history()[3]))
+    self.assert_(has_revision(br_b, br_a.revision_history()[2]))
+    self.assertEquals(len(br_b.revision_history()), 7)
+    self.assertEquals(greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0], 0)
 
     # greedy_fetch is not supposed to alter the revision history
-    assert len(br_b.revision_history()) == 7
-    assert not has_revision(br_b, br_a.revision_history()[3])
+    self.assertEquals(len(br_b.revision_history()), 7)
+    self.assertFalse(has_revision(br_b, br_a.revision_history()[3]))
 
-    assert len(br_b.revision_history()) == 7
-    assert greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0] == 1
-    assert has_revision(br_b, br_a.revision_history()[3])
-    assert not has_revision(br_a, br_b.revision_history()[6])
-    assert has_revision(br_a, br_b.revision_history()[5])
+    self.assertEquals(len(br_b.revision_history()), 7)
+    self.assertEquals(greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0], 1)
+    self.assert_(has_revision(br_b, br_a.revision_history()[3]))
+    self.assertFalse(has_revision(br_a, br_b.revision_history()[6]))
+    self.assert_(has_revision(br_a, br_b.revision_history()[5]))
 
     # When a non-branch ancestor is missing, it should be unlisted...
     # as its not reference from the inventory weave.
@@ -65,28 +65,28 @@
     self.assertEqual(failures, [])
 
     self.assertEqual(greedy_fetch(writable_a, br_b)[0], 1)
-    assert has_revision(br_a, br_b.revision_history()[3])
-    assert has_revision(br_a, br_b.revision_history()[4])
+    self.assert_(has_revision(br_a, br_b.revision_history()[3]))
+    self.assert_(has_revision(br_a, br_b.revision_history()[4]))
         
     br_b2 = new_branch('br_b2')
-    assert greedy_fetch(br_b2, br_b)[0] == 7
-    assert has_revision(br_b2, br_b.revision_history()[4])
-    assert has_revision(br_b2, br_a.revision_history()[2])
-    assert not has_revision(br_b2, br_a.revision_history()[3])
+    self.assertEquals(greedy_fetch(br_b2, br_b)[0], 7)
+    self.assert_(has_revision(br_b2, br_b.revision_history()[4]))
+    self.assert_(has_revision(br_b2, br_a.revision_history()[2]))
+    self.assertFalse(has_revision(br_b2, br_a.revision_history()[3]))
 
     br_a2 = new_branch('br_a2')
-    assert greedy_fetch(br_a2, br_a)[0] == 9
-    assert has_revision(br_a2, br_b.revision_history()[4])
-    assert has_revision(br_a2, br_a.revision_history()[3])
-    assert has_revision(br_a2, br_a.revision_history()[2])
+    self.assertEquals(greedy_fetch(br_a2, br_a)[0], 9)
+    self.assert_(has_revision(br_a2, br_b.revision_history()[4]))
+    self.assert_(has_revision(br_a2, br_a.revision_history()[3]))
+    self.assert_(has_revision(br_a2, br_a.revision_history()[2]))
 
     br_a3 = new_branch('br_a3')
-    assert greedy_fetch(br_a3, br_a2)[0] == 0
+    self.assertEquals(greedy_fetch(br_a3, br_a2)[0], 0)
     for revno in range(4):
-        assert not has_revision(br_a3, br_a.revision_history()[revno])
+        self.assertFalse(has_revision(br_a3, br_a.revision_history()[revno]))
     self.assertEqual(greedy_fetch(br_a3, br_a2, br_a.revision_history()[2])[0], 3)
     fetched = greedy_fetch(br_a3, br_a2, br_a.revision_history()[3])[0]
-    assert fetched == 3, "fetched %d instead of 3" % fetched
+    self.assertEquals(fetched, 3, "fetched %d instead of 3" % fetched)
     # InstallFailed should be raised if the branch is missing the revision
     # that was requested.
     self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
@@ -104,7 +104,7 @@
 
     def test_fetch(self):
         #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
+        br_a, br_b = make_branches(self)
         fetch_steps(self, br_a, br_b, br_a)
 
 
@@ -187,7 +187,7 @@
 
     def test_fetch(self):
         #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
+        br_a, br_b = make_branches(self)
         br_rem_a = Branch.open(self.get_remote_url(br_a._transport.base))
         fetch_steps(self, br_rem_a, br_b, br_a)
 

=== modified file 'bzrlib/selftest/testgraph.py'
--- bzrlib/selftest/testgraph.py	2005-09-21 15:33:23 +0000
+++ bzrlib/selftest/testgraph.py	2005-10-31 20:40:26 +0000
@@ -33,10 +33,10 @@
         distances = node_distances(self.graph, descendants, 'A')
         nodes = nodes_by_distance(distances)
         self.assertEqual(nodes[0], 'D')
-        assert nodes[1] in ('N', 'C')
-        assert nodes[2] in ('N', 'C')
-        assert nodes[3] in ('B', 'M')
-        assert nodes[4] in ('B', 'M')
+        self.assert_(nodes[1] in ('N', 'C'))
+        self.assert_(nodes[2] in ('N', 'C'))
+        self.assert_(nodes[3] in ('B', 'M'))
+        self.assert_(nodes[4] in ('B', 'M'))
 
         #Ensure we don't shortcut through B when there's only a difference of
         # 1 in distance

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-10-10 00:05:25 +0000
+++ bzrlib/selftest/testinv.py	2005-10-30 23:58:46 +0000
@@ -152,7 +152,7 @@
         self.inv_1 = self.branch.get_inventory('1')
         self.file_1 = self.inv_1['fileid']
         self.tree_2 = self.branch.working_tree()
-        self.inv_2 = self.branch.inventory
+        self.inv_2 = self.tree_2.read_working_inventory()
         self.file_2 = self.inv_2['fileid']
         if has_symlinks():
             self.link_1 = self.inv_1['linkid']

=== modified file 'bzrlib/selftest/testrevision.py'
--- bzrlib/selftest/testrevision.py	2005-10-10 04:13:48 +0000
+++ bzrlib/selftest/testrevision.py	2005-10-31 20:40:26 +0000
@@ -26,7 +26,8 @@
 from bzrlib.trace import mutter
 from bzrlib.errors import NoSuchRevision
 
-def make_branches():
+# XXX: Make this a method of a merge base case
+def make_branches(self):
     """Create two branches
 
     branch 1 has 6 commits, branch 2 has 3 commits
@@ -63,7 +64,7 @@
     
     fetch(from_branch=br2, to_branch=br1)
     br1.add_pending_merge(revisions_2[4])
-    assert revisions_2[4] == 'b@u-0-4'
+    self.assertEquals(revisions_2[4], 'b@u-0-4')
     commit(br1, "Commit six", rev_id="a@u-0-3")
     commit(br1, "Commit seven", rev_id="a@u-0-4")
     commit(br2, "Commit eight", rev_id="b@u-0-5")
@@ -82,7 +83,7 @@
 class TestIsAncestor(TestCaseInTempDir):
     def test_recorded_ancestry(self):
         """Test that commit records all ancestors"""
-        br1, br2 = make_branches()
+        br1, br2 = make_branches(self)
         d = [('a@u-0-0', ['a@u-0-0']),
              ('a@u-0-1', ['a@u-0-0', 'a@u-0-1']),
              ('a@u-0-2', ['a@u-0-0', 'a@u-0-1', 'a@u-0-2']),
@@ -118,22 +119,22 @@
     
     def test_is_ancestor(self):
         """Test checking whether a revision is an ancestor of another revision"""
-        br1, br2 = make_branches()
+        br1, br2 = make_branches(self)
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
         sources = br1
 
-        assert is_ancestor(revisions[0], revisions[0], br1)
-        assert is_ancestor(revisions[1], revisions[0], sources)
-        assert not is_ancestor(revisions[0], revisions[1], sources)
-        assert is_ancestor(revisions_2[3], revisions[0], sources)
+        self.assert_(is_ancestor(revisions[0], revisions[0], br1))
+        self.assert_(is_ancestor(revisions[1], revisions[0], sources))
+        self.assert_(not is_ancestor(revisions[0], revisions[1], sources))
+        self.assert_(is_ancestor(revisions_2[3], revisions[0], sources))
         # disabled mbp 20050914, doesn't seem to happen anymore
         ## self.assertRaises(NoSuchRevision, is_ancestor, revisions_2[3],
         ##                  revisions[0], br1)        
-        assert is_ancestor(revisions[3], revisions_2[4], sources)
-        assert is_ancestor(revisions[3], revisions_2[4], br1)
-        assert is_ancestor(revisions[3], revisions_2[3], sources)
-        ## assert not is_ancestor(revisions[3], revisions_2[3], br1)
+        self.assert_(is_ancestor(revisions[3], revisions_2[4], sources))
+        self.assert_(is_ancestor(revisions[3], revisions_2[4], br1))
+        self.assert_(is_ancestor(revisions[3], revisions_2[3], sources))
+        ## self.assert_(not is_ancestor(revisions[3], revisions_2[3], br1))
 
 
 class TestIntermediateRevisions(TestCaseInTempDir):
@@ -141,7 +142,7 @@
     def setUp(self):
         from bzrlib.commit import commit
         TestCaseInTempDir.setUp(self)
-        self.br1, self.br2 = make_branches()
+        self.br1, self.br2 = make_branches(self)
 
         self.br2.commit("Commit eleven", rev_id="b@u-0-7")
         self.br2.commit("Commit twelve", rev_id="b@u-0-8")
@@ -166,7 +167,7 @@
     def test_intervene(self):
         """Find intermediate revisions, without requiring history"""
         from bzrlib.errors import NotAncestor, NoSuchRevision
-        assert len(self.intervene('a@u-0-0', 'a@u-0-0')) == 0
+        self.assertEquals(len(self.intervene('a@u-0-0', 'a@u-0-0')), 0)
         self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-1'), ['a@u-0-1'])
         self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-2'), 
                          ['a@u-0-1', 'a@u-0-2'])
@@ -210,7 +211,7 @@
     def test_old_common_ancestor(self):
         """Pick a resonable merge base using the old functionality"""
         from bzrlib.revision import old_common_ancestor as common_ancestor
-        br1, br2 = make_branches()
+        br1, br2 = make_branches(self)
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
         sources = br1
@@ -222,7 +223,7 @@
                                    revisions_2[3]:(4, 2),
                                    revisions[0]:(5, 3) }
         ancestors_list = find_present_ancestors(revisions[3], sources)
-        assert len(expected_ancestors_list) == len(ancestors_list)
+        self.assertEquals(len(expected_ancestors_list), len(ancestors_list))
         for key, value in expected_ancestors_list.iteritems():
             self.assertEqual(ancestors_list[key], value, 
                               "key %r, %r != %r" % (key, ancestors_list[key],
@@ -249,7 +250,7 @@
     def test_common_ancestor(self):
         """Pick a reasonable merge base"""
         from bzrlib.revision import common_ancestor
-        br1, br2 = make_branches()
+        br1, br2 = make_branches(self)
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
         sources = MultipleRevisionSources(br1, br2)
@@ -260,7 +261,7 @@
                                    revisions_2[3]:(4, 2),
                                    revisions[0]:(5, 3) }
         ancestors_list = find_present_ancestors(revisions[3], sources)
-        assert len(expected_ancestors_list) == len(ancestors_list)
+        self.assertEquals(len(expected_ancestors_list), len(ancestors_list))
         for key, value in expected_ancestors_list.iteritems():
             self.assertEqual(ancestors_list[key], value, 
                               "key %r, %r != %r" % (key, ancestors_list[key],
@@ -286,13 +287,13 @@
         """combined_graph
         Ensure it's not order-sensitive
         """
-        br1, br2 = make_branches()
+        br1, br2 = make_branches(self)
         source = MultipleRevisionSources(br1, br2)
         combined_1 = combined_graph(br1.last_revision(), 
                                     br2.last_revision(), source)
         combined_2 = combined_graph(br2.last_revision(),
                                     br1.last_revision(), source)
-        assert combined_1[1] == combined_2[1]
-        assert combined_1[2] == combined_2[2]
-        assert combined_1[3] == combined_2[3]
-        assert combined_1 == combined_2
+        self.assertEquals(combined_1[1], combined_2[1])
+        self.assertEquals(combined_1[2], combined_2[2])
+        self.assertEquals(combined_1[3], combined_2[3])
+        self.assertEquals(combined_1, combined_2)

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-10-24 15:56:15 +0000
+++ bzrlib/selftest/teststatus.py	2005-10-31 20:40:26 +0000
@@ -111,17 +111,17 @@
         b.commit("Empty commit 2")
         merge(["./branch", -1], [None, None], this_dir = './copy')
         message = self.status_string(b_2)
-        assert (message.startswith("pending merges:\n")), message
-        assert (message.endswith("Empty commit 2\n")), message 
+        self.assert_(message.startswith("pending merges:\n"))
+        self.assert_(message.endswith("Empty commit 2\n")) 
         b_2.commit("merged")
         # must be long to make sure we see elipsis at the end
         b.commit("Empty commit 3 blah blah blah blah blah blah blah blah blah"
                  " blah blah blah blah blah blah bleh")
         merge(["./branch", -1], [None, None], this_dir = './copy')
         message = self.status_string(b_2)
-        assert (message.startswith("pending merges:\n")), message
-        assert ("Empty commit 3" in message), message
-        assert (message.endswith("...\n")), message 
+        self.assert_(message.startswith("pending merges:\n"))
+        self.assert_("Empty commit 3" in message)
+        self.assert_(message.endswith("...\n")) 
 
     def test_branch_status_specific_files(self): 
         """Tests branch status with given specific files"""

=== modified file 'bzrlib/selftest/teststore.py'
--- bzrlib/selftest/teststore.py	2005-10-19 07:25:40 +0000
+++ bzrlib/selftest/teststore.py	2005-10-31 20:52:50 +0000
@@ -32,6 +32,7 @@
 
 
 class TestStores(object):
+    """Mixin template class that provides some common tests for stores"""
 
     def check_content(self, store, fileid, value):
         f = store.get(fileid)

=== modified file 'bzrlib/selftest/testworkingtree.py'
--- bzrlib/selftest/testworkingtree.py	2005-10-24 13:57:49 +0000
+++ bzrlib/selftest/testworkingtree.py	2005-10-30 23:58:46 +0000
@@ -63,14 +63,12 @@
         branch = Branch.initialize('.')
         tree = WorkingTree(branch.base, branch)
         self.assertEqual(branch, tree.branch)
-        self.assertEqual(branch.inventory, tree._inventory)
         self.assertEqual(branch.base, tree.basedir)
     
     def test_construct_without_branch(self):
         branch = Branch.initialize('.')
         tree = WorkingTree(branch.base)
         self.assertEqual(branch.base, tree.branch.base)
-        self.assertEqual(branch.inventory, tree._inventory)
         self.assertEqual(branch.base, tree.basedir)
 
     def test_basic_relpath(self):

=== modified file 'bzrlib/selftest/treeshape.py'
--- bzrlib/selftest/treeshape.py	2005-10-04 10:10:48 +0000
+++ bzrlib/selftest/treeshape.py	2005-10-31 20:40:26 +0000
@@ -64,7 +64,7 @@
         filenames.sort()
         for fn in filenames:
             fullpath = os.path.join(dirpath, fn)
-            assert fullpath[-1] not in '@/'
+            self.assertFalse(fullpath[-1] in '@/')
             info = os.lstat(fullpath)
             if stat.S_ISLNK(info.st_mode):
                 yield (fullpath + '@', os.readlink(fullpath))

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-10-22 13:27:47 +0000
+++ bzrlib/selftest/versioning.py	2005-10-30 23:58:46 +0000
@@ -127,6 +127,7 @@
         chdir = os.chdir
         
         b = Branch.initialize('.')
+        t = b.working_tree()
         self.build_tree(['src/', 'README'])
         
         eq(sorted(b.unknowns()),
@@ -141,7 +142,7 @@
         
         eq(sorted(b.unknowns()), 
            ['README'])
-        eq(len(b.inventory), 3)
+        eq(len(t.read_working_inventory()), 3)
                 
         chdir('..')
         self.run_bzr('add')

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-10-16 22:04:54 +0000
+++ bzrlib/selftest/whitebox.py	2005-10-30 23:58:46 +0000
@@ -97,11 +97,11 @@
 
         b.rename_one('dir', 'newdir')
 
-        self.check_inventory_shape(b.inventory,
+        self.check_inventory_shape(b.working_tree().read_working_inventory(),
                                    ['newdir', 'newdir/sub', 'newdir/sub/file'])
 
         b.rename_one('newdir/sub', 'newdir/newsub')
-        self.check_inventory_shape(b.inventory,
+        self.check_inventory_shape(b.working_tree().read_working_inventory(),
                                    ['newdir', 'newdir/newsub',
                                     'newdir/newsub/file'])
 

=== modified file 'bzrlib/store/compressed_text.py'
--- bzrlib/store/compressed_text.py	2005-10-17 02:16:12 +0000
+++ bzrlib/store/compressed_text.py	2005-10-31 20:52:50 +0000
@@ -81,13 +81,13 @@
     def _copy_one(self, fileid, suffix, other, pb):
         if not (isinstance(other, CompressedTextStore)
             and other._prefixed == self._prefixed):
-            return super(CompressedTextStore, self)._copy_one(fileid, suffix,
-                                                              other, pb)
+            return super(CompressedTextStore, self)._copy_one(fileid, suffix, other, pb)
         if suffix is None or suffix == 'gz':
             path = self._relpath(fileid)
         else:
             path = self._relpath(fileid, [suffix])
-        assert other._transport.copy_to([path], self._transport, pb=pb) == 1
+        result = other._transport.copy_to([path], self._transport, pb=pb)
+        assert result == 1      # or what???
 
     def __init__(self, transport, prefixed=False):
         super(CompressedTextStore, self).__init__(transport, prefixed)

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-10-26 23:47:27 +0000
+++ bzrlib/trace.py	2005-10-28 07:20:11 +0000
@@ -85,7 +85,6 @@
 # configure convenient aliases for output routines
 
 _bzr_logger = logging.getLogger('bzr')
-_bzr_logger.setLevel(logging.DEBUG) 
 
 info = note = _bzr_logger.info
 warning =   _bzr_logger.warning
@@ -203,6 +202,7 @@
 
     _stderr_handler.setLevel(logging.INFO)
     _file_handler.setLevel(level)
+    _bzr_logger.setLevel(level) 
 
     logging.getLogger('').addHandler(_stderr_handler)
 

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2005-10-30 13:36:25 +0000
+++ bzrlib/transport/sftp.py	2005-10-31 17:17:04 +0000
@@ -87,7 +87,7 @@
     Transport implementation for SFTP access.
     """
 
-    _url_matcher = re.compile(r'^sftp://(.*@)?(.*?)(:\d+)?(/.*)?$')
+    _url_matcher = re.compile(r'^sftp://([^:@]*(:[^@]*)?@)?(.*?)(:\d+)?(/.*)?$')
     
     def __init__(self, base, clone_from=None):
         assert base.startswith('sftp://')
@@ -148,7 +148,7 @@
                 basepath.append(p)
 
         path = '/'.join(basepath)
-        if path[0] != '/':
+        if len(path) and path[0] != '/':
             path = '/' + path
         return path
 
@@ -364,11 +364,14 @@
         m = self._url_matcher.match(url)
         if m is None:
             raise SFTPTransportError('Unable to parse SFTP URL %r' % (url,))
-        self._username, self._host, self._port, self._path = m.groups()
+        self._username, self._password, self._host, self._port, self._path = m.groups()
         if self._username is None:
             self._username = getpass.getuser()
         else:
             self._username = self._username[:-1]
+        if self._password:
+            self._password = self._password[1:]
+            self._username = self._username[len(self._password)+1:]
         if self._port is None:
             self._port = 22
         else:
@@ -435,6 +438,13 @@
         if self._try_pkey_auth(transport, paramiko.DSSKey, 'id_dsa'):
             return
 
+        if self._password:
+            try:
+                transport.auth_password(self._username, self._password)
+                return
+            except paramiko.SSHException, e:
+                pass
+
         # give up and ask for a password
         password = getpass.getpass('SSH %s@%s password: ' % (self._username, self._host))
         try:

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-10-29 23:48:45 +0000
+++ bzrlib/workingtree.py	2005-10-30 23:58:46 +0000
@@ -51,6 +51,7 @@
 from bzrlib.osutils import appendpath, file_kind, isdir, splitpath, relpath
 from bzrlib.errors import BzrCheckError, DivergedBranches, NotVersionedError
 from bzrlib.trace import mutter
+import bzrlib.xml5
 
 
 class TreeEntry(object):
@@ -134,10 +135,10 @@
             branch = Branch.open(basedir)
         assert isinstance(branch, Branch), \
             "branch %r is not a Branch" % branch
-        self._inventory = branch.inventory
-        self.path2id = self._inventory.path2id
         self.branch = branch
         self.basedir = basedir
+        self._inventory = self.read_working_inventory()
+        self.path2id = self._inventory.path2id
 
         # update the whole cache up front and write to disk if anything changed;
         # in the future we might want to do this more selectively
@@ -187,6 +188,11 @@
     def get_file_byname(self, filename):
         return file(self.abspath(filename), 'rb')
 
+    def get_root_id(self):
+        """Return the id of this trees root"""
+        inv = self.read_working_inventory()
+        return inv.root.file_id
+        
     def _get_store_filename(self, file_id):
         ## XXX: badly named; this isn't in the store at all
         return self.abspath(self.id2path(file_id))
@@ -450,6 +456,14 @@
         """See Branch.lock_write, and WorkingTree.unlock."""
         return self.branch.lock_write()
 
+    @needs_read_lock
+    def read_working_inventory(self):
+        """Read the working inventory."""
+        # ElementTree does its own conversion from UTF-8, so open in
+        # binary.
+        f = self.branch.controlfile('inventory', 'rb')
+        return bzrlib.xml5.serializer_v5.read_inventory(f)
+
     @needs_write_lock
     def remove(self, files, verbose=False):
         """Remove nominated files from the working inventory..
@@ -491,6 +505,29 @@
 
         self.branch._write_inventory(inv)
 
+    @needs_write_lock
+    def set_inventory(self, new_inventory_list):
+        from bzrlib.inventory import (Inventory,
+                                      InventoryDirectory,
+                                      InventoryEntry,
+                                      InventoryFile,
+                                      InventoryLink)
+        inv = Inventory(self.get_root_id())
+        for path, file_id, parent, kind in new_inventory_list:
+            name = os.path.basename(path)
+            if name == "":
+                continue
+            # fixme, there should be a factory function inv,add_?? 
+            if kind == 'directory':
+                inv.add(InventoryDirectory(file_id, name, parent))
+            elif kind == 'file':
+                inv.add(InventoryFile(file_id, name, parent))
+            elif kind == 'symlink':
+                inv.add(InventoryLink(file_id, name, parent))
+            else:
+                raise BzrError("unknown kind %r" % kind)
+        self.branch._write_inventory(inv)
+
     def unlock(self):
         """See Branch.unlock.
         

=== modified file 'contrib/zsh/_bzr'
--- contrib/zsh/_bzr	2005-10-14 10:37:07 +0000
+++ contrib/zsh/_bzr	2005-10-31 15:50:52 +0000
@@ -9,12 +9,308 @@
 # how to get zsh to reload this file when it changes, other than by
 # starting a new zsh.
 
-local _bzr_subcommands expl curcontext="$curcontext"
-
-_bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
-
-if (( CURRENT == 2 )); then
-  _describe -t subcommand 'subcommand' _bzr_subcommands
-else
-# this part missing
+local _bzr_subcommands expl curcontext="$curcontext" state line
+local bzrRoot helpArgs parentFile
+typeset -A opt_args
+
+helpArgs=( '(--help)-h[show help message]' '(-h)--help[show help message]' )
+bzrRoot=$(bzr root 2> /dev/null)
+parentFile=$bzrRoot/.bzr/parent
+
+if [[ $service == "bzr" ]]; then
+    _arguments -C -A "-*" \
+    '*::command:->subcmd' && return 0
+
+    if (( CURRENT == 1 )); then
+      _bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
+      _describe -t subcommand 'subcommand' _bzr_subcommands
+      return
+    fi
+
+    service="$words[1]"
+    curcontext="${curcontext%:*}=$service:"
 fi
+
+_unknownFiles() {
+    local fileList;
+    fileList=(${(ps:\0:)"$(bzr ls --null --unknown)"})
+    compadd -af fileList
+    return 0
+}
+
+_unknownRoot() {
+    local fileList;
+    fileList=(${(ps:\0:)"$(bzr ls --null --from-root --unknown)"})
+    compadd -af fileList
+    return 0
+}
+
+_versionedFiles() {
+    local fileList;
+    fileList=(${(ps:\0:)"$(bzr ls --null --versioned)"})
+    compadd -af fileList
+    return 0
+}
+
+case $service in
+    (add)
+       _arguments $helpArgs \
+       '--no-recurse[do not recurse into subdirectories]' \
+       '(-q)--quiet' \
+       '(--quiet)-q' \
+       '*:unknown files:_unknownFiles'
+    ;;
+
+    (annotate|praise|blame)
+        _arguments $helpArgs '*:files:_versionedFiles'
+    ;;
+
+    (clone|branch|get)
+        if (( CURRENT == 2 )); then
+            _arguments $helpArgs \
+            '(-r)--revision:rev:' \
+            '(--revision)-r:rev:' \
+            '--basis[specify basis branch]:basis:' \
+            '*:FROM_LOCATION:_files -/'
+        elif (( CURRENT == 3 )); then
+            _arguments $helpArgs \
+            '(-r)--revision:rev:' \
+            '(--revision)-r:rev:' \
+            '--basis[specify basis branch]:basis:' \
+            '*:TO_LOCATION:_files -/'
+        fi
+    ;;
+
+    (rename|mv)
+        if (( CURRENT == 2 )); then
+            _arguments $helpArgs '*:old name:_versionedFiles'
+        else
+            _arguments $helpArgs '*:new name:'
+        fi
+    ;;
+
+    (cat)
+        _arguments $helpArgs \
+        '(-r)--revision:rev:' \
+        '(--revision)-r:rev:' \
+        '*:file:_versionedFiles'
+    ;;
+
+    (root)
+        _arguments $helpArgs '*:file:_files'
+    ;;
+
+    (log)
+        _arguments $helpArgs \
+        '(-r)--revision[revision or range]:rev or rev range:' \
+        '(--revision)-r[revision or range]:rev or rev range:' \
+        '(--verbose)-v[show revision manifest]' \
+        '(-v)--verbose[show revision manifest]' \
+        '(--short --long)-l[use long format (default)]' \
+        '(--short -l)--long[use long format (default)]' \
+        '(-l --long)--short[use short format]' \
+        '(--message)-m[specify regexp]:regexp:' \
+        '(-m)--message[specify regexp]:regexp:' \
+        '--show-ids[show file IDs]' \
+        '--forward[reverse direction of revisions]' \
+        '--timezoe[specify timezone for dates]:timezone:' \
+        '*:file:_versionedFiles'
+    ;;
+
+    (resolve)
+        _arguments $helpArgs '--all' '*:file:_versionedFiles'
+    ;;
+
+    (status|st|stat)
+        _arguments $helpArgs \
+        '--all[include unchanged versioned files]' \
+        '--show-ids[show file IDs]' \
+        '*:file:_versionedFiles'
+    ;;
+
+    (check)
+        _arguments $helpArgs \
+        '(--verbose)-v' \
+        '(-v)--verbose' \
+        '*:DIR:_files -/'
+    ;;
+
+    (mkdir|upgrade|renames)
+        _arguments $helpArgs '*:DIR:_files -/'
+    ;;
+
+    (remove|rm)
+        _arguments $helpArgs \
+        '(--verbose)-v' \
+        '(-v)--verbose' \
+        '*:file:_versionedFiles'
+    ;;
+
+    (pull)
+        _arguments $helpArgs \
+        '--remember[Remember the specified location as a default]' \
+        '--overwrite[Ignore differences, overwrite unconditionally]' \
+        '*:local repository:_files -/'
+        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
+    ;;
+
+    (missing|miss|mis)
+        _arguments $helpArgs \
+        '(--verbose -q --quiet)-v' \
+        '(-v -q --quiet)--verbose' \
+        '(--verbose -v --quiet)-q' \
+        '(-v -q --verbose)--quiet' \
+        '*:local repository:_files -/'
+        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
+    ;;
+
+    (commit|checkin|ci)
+        _arguments $helpArgs \
+        '(--message)-m[commit message]:message text:' \
+        '(-m)--message[commit message]:message text:' \
+        '(--file)-F[commit message from file]:message file:' \
+        '(-F)--file[commit message from file]:message file:' \
+        '--unchanged[include unchanged files]' \
+        '(--verbose)-v' \
+        '(-v)--verbose' \
+        '*:modified files:_versionedFiles'
+    ;;
+
+    (conflicts|added|deleted|modified|unknowns|directories|ignored)
+        _arguments $helpArgs
+    ;;
+
+    (revno|init|version)
+        _arguments $helpArgs
+    ;;
+
+    (whoami)
+        _arguments $helpArgs '--email[only show e-mail address]' 
+    ;;
+
+    (inventory)
+        _arguments $helpArgs \
+        '(-r)--revision[show inventory of a revision]:revision:' \
+        '(--revision)-r[show inventory of a revision]:revision:' \
+        '--show-ids[show file IDs]'
+    ;;
+
+    (diff|dif|di)
+        _arguments $helpArgs \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '--diff-options[options to pass to gdiff]:diff options:' \
+        '*:files:_files'
+    ;;
+
+    (export)
+        _arguments $helpArgs \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '--format=[format of exported file]:format:(dir tar tgz tbz2)' \
+        '--root[root directory of patch]:_files -/' \
+        '*:destination:_files'
+    ;;
+
+    (ignore)
+        _arguments $helpArgs '*:NAME_PATTERN:_unknownRoot'
+    ;;
+
+    (info)
+        _arguments $helpArgs '*:branch:_files -/'
+    ;;
+
+    (testament)
+        _arguments $helpArgs \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '(--long)-l' \
+        '(-l)--long' \
+        '*:branch:_files -/'
+    ;;
+
+    (revert|merge-revert)
+        _arguments $helpArgs \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '--no-backup[skip generation of backup~ files]' \
+        '*:file:_versionedFiles'
+    ;;
+
+    (merge)
+        _arguments $helpArgs \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '--reprocess[Reprocess to reduce spurious conflicts]' \
+        '--show-base[Show base revision text in conflicts]' \
+        '--force[ignore uncommitted changes]' \
+        '--merge-type:merge type:(diff3 merge3 weave)' \
+        '*:local repository:_files -/'
+        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
+    ;;
+
+    (ls)
+        _arguments $helpArgs \
+        '(--verbose)-v[display more information]' \
+        '(-v)--verbose[display more information]' \
+        '(-r)--revision:revision:' \
+        '(--revision)-r:revision:' \
+        '--from-root[Print all paths from the root of the branch]' \
+        '--non-recursive[Do not recurse into subdirectories]' \
+        '--null[Null separate the files]' \
+        '--ignored[Print ignored files]' \
+        '--unknown[Print unknown files]' \
+        '--versioned[Print versioned files]'
+    ;;
+
+    (move)
+        if (( CURRENT == 2 )); then
+            _arguments $helpArgs '*:files:_versionedFiles'
+        else
+            _arguments '*:destination dir:_files -/'
+        fi
+    ;;
+
+    (help)
+        _bzr_subcommands=(${(f)"$(_call_program bzr bzr shell-complete)"})
+        _arguments $helpArgs \
+        '(--long)-l' \
+        '(-l)--long' \
+        '*:subcmds:->cmds'
+        _describe -t subcommand 'subcommand' _bzr_subcommands
+    ;;
+
+    # Plugins
+
+    (visualize|visualise|viz|vis)
+        _arguments $helpArgs \
+            '(-r)--revision[starting revision]:rev:' \
+            '(--revision)-r[starting revision]:rev:'
+    ;;
+
+    (gannotate|gblame|gpraise)
+        _arguments $helpArgs \
+            '--all[show annotations on all lines]' \
+            '--plain[do not hightlight annotation lines]' \
+            '*:files:_versionedFiles'
+    ;;
+
+    (push)
+        _arguments $helpArgs \
+        '--overwrite[Ignore differences, overwrite unconditionally]' \
+        '*:local repository:_files -/'
+        [[ -r $parentFile ]] && compadd -X "Completing parents" $(cat $parentFile)
+    ;;
+
+    (clean-tree)
+        _arguments $helpArgs \
+        '--dry-run[show files to delete instead of deleting them]' \
+        '--ignored[delete all ignored files]' \
+        '--detritus[delete conflict files, merge backups, failed self-tests, *~, *.tmp, etc]'
+    ;;
+
+
+    (*)
+        _message "unknown bzr command completion: $service"
+    ;;
+esac

=== modified file 'setup.py'
--- setup.py	2005-10-28 04:31:55 +0000
+++ setup.py	2005-10-31 17:21:15 +0000
@@ -4,9 +4,39 @@
 # './setup.py install', or
 # './setup.py --help' for more options
 
+# Reinvocation stolen from bzr, we need python2.4 by virtue of bzr_man
+# including bzrlib.help
+
+import os, sys
+
+try:
+    version_info = sys.version_info
+except AttributeError:
+    version_info = 1, 5 # 1.5 or older
+
+REINVOKE = "__BZR_REINVOKE"
+NEED_VERS = (2, 4)
+KNOWN_PYTHONS = ('python2.4',)
+
+if version_info < NEED_VERS:
+    if not os.environ.has_key(REINVOKE):
+        # mutating os.environ doesn't work in old Pythons
+        os.putenv(REINVOKE, "1")
+        for python in KNOWN_PYTHONS:
+            try:
+                os.execvp(python, [python] + sys.argv)
+            except OSError:
+                pass
+    print >>sys.stderr, "bzr: error: cannot find a suitable python interpreter"
+    print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
+    sys.exit(1)
+if hasattr(os, "unsetenv"):
+    os.unsetenv(REINVOKE)
+
+
 from distutils.core import setup
 from distutils.command.install_scripts import install_scripts
-
+from distutils.command.build import build
 
 ###############################
 # Overridden distutils actions
@@ -36,12 +66,22 @@
                 print "ERROR: Unable to create %s: %s" % (batch_path, e)
 
 
+class bzr_build(build):
+    """Customized build distutils action.
+    Generate bzr.1.
+    """
+    def run(self):
+        build.run(self)
+
+        import bzr_man
+        bzr_man.main()
+
 ########################
 ## Setup
 ########################
 
 setup(name='bzr',
-      version='0.1',
+      version='0.7pre',
       author='Martin Pool',
       author_email='mbp@sourcefrog.net',
       url='http://www.bazaar-ng.org/',
@@ -58,5 +98,6 @@
                 'bzrlib.util.configobj',
                 ],
       scripts=['bzr'],
-      cmdclass={'install_scripts': my_install_scripts},
+      cmdclass={'install_scripts': my_install_scripts, 'build': bzr_build},
+      data_files=[('man/man1', ['bzr.1'])],
      )

